/*
  INF3105 - Structures de données et algorithmes
  UQAM / Département d'informatique
  Lab5
  Auteur : Eric Beaudry
*/

#include <iostream>

#include "liste.h"

class PassageCarte {
 public:

 private:
  int temps;
  int numero_carte;

  friend std::istream& operator>>(std::istream&, PassageCarte&);
  friend std::ostream& operator<<(std::ostream&, const PassageCarte&);
  friend class Historique;
};

class Historique {
 public:
  Historique(int exp_delai = 600) : expiration_delai(exp_delai) {}

  bool valider(const PassageCarte& carte);

 private:
  Liste<PassageCarte> passages;
  int expiration_delai;
};

std::istream& operator>>(std::istream& is, PassageCarte& pc) {
  is >> pc.temps >> pc.numero_carte;
  return is;
}

std::ostream& operator<<(std::ostream& os, const PassageCarte& pc) {
  os << pc.temps << "\t" << pc.numero_carte;
  return os;
}

bool Historique::valider(const PassageCarte& passage) {
  // Supprimer les passages expirés
  Liste<PassageCarte>::Iterateur iter(passages);
  while (iter && (passage.temps - passages[iter].temps > expiration_delai))
    iter = passages.enlever(iter);

  // Recherche de la carte
  while (iter) {
    if (passages[iter].numero_carte == passage.numero_carte) return false;
    ++iter;
  }

  // Ajout
  passages.inserer_fin(passage);

  return true;
}

int main() {
  Historique historique;
  while (std::cin) {
    PassageCarte pc;
    std::cin >> pc;
    if (std::cin)
      if (!historique.valider(pc))
        std::cout << "Passage invalide : " << pc << "!" << std::endl;
  }
}
